package com.leodesol.games.puzzlecollection;

import com.badlogic.gdx.backends.iosmoe.IOSApplication;
import com.badlogic.gdx.backends.iosmoe.IOSApplicationConfiguration;
import org.moe.natj.general.Pointer;
import com.leodesol.games.puzzlecollection.PuzzleCollectionGame;

import apple.foundation.NSArray;
import apple.foundation.NSData;
import apple.foundation.NSError;
import apple.foundation.NSURL;
import apple.gamekit.GKLocalPlayer;
import apple.gamekit.GKScore;
import apple.uikit.UIApplication;
import apple.uikit.UIViewController;
import apple.uikit.c.UIKit;

public class IOSMoeLauncher extends IOSApplication.Delegate {

    protected IOSMoeLauncher(Pointer peer) {
        super(peer);
    }

    @Override
    protected IOSApplication createApplication() {
        IOSApplicationConfiguration config = new IOSApplicationConfiguration();
        config.useAccelerometer = false;
        GKLocalPlayer.localPlayer().setAuthenticateHandler(new GKLocalPlayer.Block_setAuthenticateHandler() {
            @Override
            public void call_setAuthenticateHandler(UIViewController viewController, NSError error) {
                if (viewController != null) {
                    UIApplication.sharedApplication().keyWindow().rootViewController().presentViewControllerAnimatedCompletion(viewController, true, null);
                }
                // If the viewController is null and the player is authenticated, the login is completed
                else if (GKLocalPlayer.localPlayer().isAuthenticated()) {
                    GKLocalPlayer.localPlayer().generateIdentityVerificationSignatureWithCompletionHandler(new GKLocalPlayer.Block_generateIdentityVerificationSignatureWithCompletionHandler() {
                        @Override
                        public void call_generateIdentityVerificationSignatureWithCompletionHandler(NSURL arg0, NSData arg1, NSData arg2, long arg3, NSError arg4) {
                            System.out.println("#####login successful :)");
                            GKScore scoreReporter = GKScore.alloc();
                            scoreReporter.setValue(45);
                            scoreReporter.setLeaderboardIdentifier("leaderboard_puzzlerama_player_level");
                            NSArray<GKScore> scores = (NSArray<GKScore>) NSArray.alloc();
                            scores.add(scoreReporter);
                            GKScore.reportScoresWithCompletionHandler(scores, new GKScore.Block_reportScoresWithCompletionHandler() {
                                @Override
                                public void call_reportScoresWithCompletionHandler(NSError error) {
                                    if (error != null) {
                                        System.out.println("#####score report error :'( " + error.localizedDescription());
                                    } else {
                                        System.out.println("#####score report successful :)");
                                    }
                                }
                            });
                        }
                    });
                }
            }
        });
        return new IOSApplication(new PuzzleCollectionGame(), config);
    }

    public static void main(String[] argv) {
        UIKit.UIApplicationMain(0, null, null, IOSMoeLauncher.class.getName());
    }
}
